Const GN_HEADERCLICK	=1				'User clicked header
Const GN_BUTTONCLICK	=2				'Sendt when user clicks the button in a button cell
Const GN_CHECKCLICK	=3				'Sendt when user double clicks the checkbox in a checkbox cell
Const GN_IMAGECLICK	=4				'Sendt when user double clicks the image in an image cell
Const GN_BEFORESELCHANGE=5				'Sendt when user request a selection change
Const GN_AFTERSELCHANGE	=6				'Sendt after a selection change
Const GN_BEFOREEDIT	=7				'Sendt before the cell edit control shows
Const GN_AFTEREDIT	=8				'Sendt when the cell edit control is about to close
Const GN_BEFOREUPDATE	=9				'Sendt before a cell updates grid data
Const GN_AFTERUPDATE	=10				'Sendt after grid data has been updated
Const GN_USERCONVERT	=11				'Sendt when user cell needs to be converted.
Const GN_EDITCHANGE	=12				'Sendt when user types text in the edit control.

'Messages
Const WM_USER            = &H400
Const GM_ADDCOL		 = WM_USER+1	'0,lpCOLUMN:COLUMN Ptr
Const GM_ADDROW		 = WM_USER+2	'0,lpROWDATA:Any Ptr
Const GM_INSROW		 = WM_USER+3	'nRow:Integer,lpROWDATA:Any Ptr
Const GM_DELROW		 = WM_USER+4	'nRow:Integer,0
Const GM_MOVEROW	 = WM_USER+5	'nFromRow:Integer,nToRow:Integer
Const GM_COMBOADDSTRING  = WM_USER+6	'nCol:Integer,lpszString:ZString Ptr
Const GM_COMBOCLEAR	 = WM_USER+7	'nCol:Integer,0
Const GM_GETCURSEL	 = WM_USER+8	'0,0|Integer
Const GM_SETCURSEL	 = WM_USER+9	'nCol:Integer,nRow:Integer
Const GM_GETCURCOL	 = WM_USER+10	'0,0|Integer
Const GM_SETCURCOL	 = WM_USER+11	'nCol:Integer,0
Const GM_GETCURROW	 = WM_USER+12	'0,0|Integer
Const GM_SETCURROW	 = WM_USER+13	'nRow:Integer,0
Const GM_GETCOLCOUNT	 = WM_USER+14	'0,0
Const GM_GETROWCOUNT	 = WM_USER+15	'0,0|Integer
Const GM_GETCELLDATA	 = WM_USER+16	'nRowCol:Integer,lpData:Any Ptr
Const GM_SETCELLDATA	 = WM_USER+17	'nRowCol:Integer,lpData:Any Ptr
Const GM_GETCELLRECT	 = WM_USER+18	'nRowCol:Integer,lpRECT:RECT Ptr
Const GM_SCROLLCELL	 = WM_USER+19	'0,0
Const GM_GETBACKCOLOR	 = WM_USER+20	'0,0
Const GM_SETBACKCOLOR	 = WM_USER+21	'nColor:Integer,0
Const GM_GETGRIDCOLOR	 = WM_USER+22	'0,0|Integer
Const GM_SETGRIDCOLOR	 = WM_USER+23	'nColor:Integer,0
Const GM_GETTEXTCOLOR	 = WM_USER+24	'0,0|Integer
Const GM_SETTEXTCOLOR	 = WM_USER+25	'nColor:Integer,0
Const GM_ENTEREDIT	 = WM_USER+26	'nCol:Integer,nRow:Integer
Const GM_ENDEDIT	 = WM_USER+27	'nRowCol:Integer,bCancel[FALSE,TRUE]
Const GM_GETCOLWIDTH	 = WM_USER+28	'nCol:Integer,0|Integer
Const GM_SETCOLWIDTH	 = WM_USER+29	'nCol:Integer,nWidth:Integer
Const GM_GETHDRHEIGHT	 = WM_USER+30	'0,0|Integer
Const GM_SETHDRHEIGHT	 = WM_USER+31	'0,nHeight:Integer
Const GM_GETROWHEIGHT	 = WM_USER+32	'nRow:Integer,0|Integer
Const GM_SETROWHEIGHT	 = WM_USER+33	'0,nHeight:Integer
Const GM_RESETCONTENT	 = WM_USER+34	'0,0
Const GM_COLUMNSORT	 = WM_USER+35	'nCol:Integer,nSort[SORT_ASCENDING,SORT_DESCENDING,SORT_INVERT]
Const GM_GETHDRTEXT	 = WM_USER+36	'nCol:Integer,lpBuffer:ZString Ptr
Const GM_SETHDRTEXT	 = WM_USER+37	'nCol:Integer,lpszText:ZString Ptr
Const GM_GETCOLFORMAT	 = WM_USER+38	'nCol:Integer,lpBuffer:ZString Ptr
Const GM_SETCOLFORMAT	 = WM_USER+39	'nCol:Integer,lpszText:ZString Ptr
Const GM_CELLCONVERT	 = WM_USER+40	'nRowCol:Integer,lpszBuffer:ZString Ptr
Const GM_RESETCOLUMNS	 = WM_USER+41	'0,0
Const GM_GETROWCOLOR	 = WM_USER+42	'nRow:Integer,lpROWCOLOR:ROWCOLOR Ptr
Const GM_SETROWCOLOR	 = WM_USER+43	'nRow:Integer,lpROWCOLOR:ROWCOLOR Ptr
Const GM_GETCOLDATA      = WM_USER+44	'nCol:Integer,lpCOLUMN:COLUMN Ptr
Const GM_COMBOFINDSTRING = WM_USER+45	'nCol:Integer,lpszString:ZString Ptr

'Column alignment
Const GA_ALIGN_LEFT	=0
Const GA_ALIGN_CENTER	=1
Const GA_ALIGN_RIGHT	=2

'Column types
Const TYPE_EDITTEXT	=0				'String
Const TYPE_EDITLONG	=1				'Long
Const TYPE_CHECKBOX	=2				'Long
Const TYPE_COMBOBOX	=3				'Long
Const TYPE_HOTKEY	=4				'Long
Const TYPE_BUTTON	=5				'String
Const TYPE_IMAGE	=6				'Long
Const TYPE_DATE	        =7				'Long
Const TYPE_TIME		=8				'Long
Const TYPE_USER		=9				'0=String, 1 to 512 bytes binary data
Const TYPE_EDITBUTTON	=10				'String
Const TYPE_EDITCOMBOBOX	=11				'String

'Column sorting
Const SORT_ASCENDING	=0
Const SORT_DESCENDING	=1
Const SORT_INVERT	=2

'Window styles
Const STYLE_NOSEL	= &H01
Const STYLE_NOFOCUS     = &H02
Const STYLE_HGRIDLINES  = &H04
Const STYLE_VGRIDLINES  = &H08
Const STYLE_GRIDFRAME	= &H10
Const STYLE_NOCOLSIZE	= &H20

Const ODT_GRID		=6

Type COLUMN
	colwt       As Integer					'Column width
	lpszhdrtext As Integer 'PTSTR				'Pointer to header text.
	halign      As Integer					'Header text alignment.
	calign      As Integer					'Column text alignment.
	ctype       As Integer					'Column data type.
	ctextmax    As Integer					'Max text lenght for TYPE_EDITTEXT and TYPE_EDITLONG.
	lpszformat  As Integer 'PTSTR				'Format string for TYPE_EDITLONG.
	himl        As Integer					'Handle of image list. For the image columns and combobox only.
	hdrflag     As Integer					'Header flags.
	colxp       As Integer					'Column position. Internally used.
	edthwnd     As Integer					'Column control handle. Internally used.
	lParam      As Integer					'User defined 32 bit value.
End Type

Type ROWCOLOR
	backcolor As Integer
	textcolor As Integer
End Type

'Notifications
Type GRIDNOTIFY
	nmhdr   As NMHDR
	col     As Integer								'Column
	row     As Integer								'Row
	hwnd    As Integer 'HWND								'Handle of column edit control
	lpdata  As Integer 'Any Ptr							'Pointer to data
	fcancel As Integer						'Set to TRUE to cancel operation
End Type


